namespace NXyn.Aux
    open System

    module SetMisc = 

        let set_tryFind (f:'a -> bool) (set:Set<'a>) : option<'a> =
            let valueOption = ref None
            Set.exists (fun(el) -> if f(el) then begin valueOption := Some(el); true end else false) set |> ignore
            !valueOption

        let set_tryPick (f:'a -> option<'b>) (set:Set<'a>) : option<'b> =
            let valueOption = ref None
            Set.exists (fun(el) -> match f(el) with None -> false | Some(res) -> valueOption := Some(res); true) set |> ignore
            !valueOption

        let sets_intersect s1 s2 = Set.intersect s1 s2 |> Set.isEmpty |> not

